const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function (sequelize, DataTypes) {
  const countries = sequelize.define(
    'countries',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

      name: {
        type: DataTypes.TEXT,
      },

      currency: {
        type: DataTypes.TEXT,
      },

      default_prefill: {
        type: DataTypes.TEXT,
      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  countries.associate = (db) => {
    /// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity

    db.countries.hasMany(db.clients, {
      as: 'clients_country',
      foreignKey: {
        name: 'countryId',
      },
      constraints: false,
    });

    db.countries.hasMany(db.markets, {
      as: 'markets_country',
      foreignKey: {
        name: 'countryId',
      },
      constraints: false,
    });

    //end loop

    db.countries.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.countries.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };

  return countries;
};
